/*
***************************************************************

    this program is used to find the existance of duplicated
    function declaration and definition. It takes the output
    file generated by rule file dupdec.cc.

***************************************************************
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LINE_LEN 1024
#define STATIC 0
#define EXTERN 1
#define GLOBAL 2
#define STRING_END '\0'

#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

typedef struct FcnRec *FRPtr;

struct FcnRec    /* stuct holding function information */
{
    char* fcnName;
    char* filName;
    char* modName;
    int   isDefine;
    int   scopeKind;
    int   lineNo;
    FRPtr next;
};

void main( int argc, char** argv )
{
    FRPtr fcnList,
          fcnRecPtr,
          curr,
          prev;
    char* modName;
    int   i,
          j;
    int   comp;
    int   repeat;
    char  line[MAX_LINE_LEN];
    FILE* fd;

    if ( argc != 2 )
    {
        printf( "error : usage : %s outfile_of_rulefile\n", argv[0] );
        exit( -1 );
    }

    fd = fopen( argv[1], "r" );
    if ( fd == NULL )
    {
        printf( "error : can not open file %s\n", argv[1] );
        exit( -1 );
    }

    fcnList = NULL;

    while ( fgets( line, MAX_LINE_LEN, fd ) )
    {
        if ( line[strlen( line ) - 1] == '\n' )
        {
            line[strlen( line ) - 1] = STRING_END;
        }

        switch ( line[0] )
        {
            case '#' :
                if ( strncmp( line + 1, "mod-begin", 9 ) == 0 )
                {
                    modName = (char*)malloc( strlen( line + 11 ) + 1 );
                    strcpy( modName, line + 11 );
                }
                else
                {
                    free( modName );
                    modName = NULL;
                }
                break;

            case '$' :
                fcnRecPtr = (FRPtr)malloc( sizeof( struct FcnRec ) );

                fcnRecPtr->modName = (char*)malloc( strlen( modName) + 1 ); 
                strcpy( fcnRecPtr->modName, modName );

                switch ( line[1] )
                {
                    case '!' :
                        fcnRecPtr->isDefine = TRUE;
                        break;

                    case '@' :
                        fcnRecPtr->isDefine = FALSE;
                        break;

                    default :
                        printf( "error : file %s has been modified\n" );
                        exit( -1 );
                        break;
                }

                switch ( line[2] )
                {
                    case 's' :
                        fcnRecPtr->scopeKind = STATIC;
                        break;

                    case 'e' :
                        fcnRecPtr->scopeKind = EXTERN;
                        break;

                    case 'g' :
                        fcnRecPtr->scopeKind = GLOBAL;
                        break;

                    default :
                        printf( "error : file %s has been modified\n" );
                        exit( -1 );
                        break;
                }

                i = 0;
                while ( line[i + 4] != '*' )
                {
                    i++;
                }
                line[i + 4] = STRING_END;
                i++;
                fcnRecPtr->fcnName = (char*)malloc( i );
                strcpy( fcnRecPtr->fcnName, line + 4 );

                j = 0;
                while ( line[j + i + 4] != '*' )
                {
                    j++;
                }
                line[j + i + 4] = STRING_END;
                j++;
                fcnRecPtr->filName = (char*)malloc( j );
                strcpy( fcnRecPtr->filName, line + i + 4 );

                fcnRecPtr->lineNo = atoi( line + i + j + 4 );
                fcnRecPtr->next = NULL;

                curr = fcnList;
                prev = NULL;

                while ( curr != NULL )
                {
                    comp = strcmp( fcnRecPtr->fcnName, curr->fcnName );
                    if ( comp == 0 )
                    {
                        if ( strcmp( fcnRecPtr->modName, curr->modName ) >= 0 )
                        {
                            prev = curr;
                            curr = curr->next;
                        }
                        else
                        {
                            prev->next = fcnRecPtr;
                            fcnRecPtr->next = curr;
                        }
                    }
                    else
                    {
                        if ( comp > 0 )
                        {
                            prev = curr;
                            curr = curr->next;
                        }
                        else
                        {
                            if ( prev == NULL )
                            {
                                fcnList = fcnRecPtr;
                                fcnRecPtr->next = curr;
                                break;
                            }
                            else
                            {
                                fcnRecPtr->next = curr;
                                prev->next = fcnRecPtr; 
                                break;
                            }
                        }
                    }
                }
                if ( curr == NULL )
                {
                    if ( prev == NULL )
                    {
                        fcnList = fcnRecPtr;
                    }
                    else
                    { 
                        prev->next = fcnRecPtr;
                    }
                }
                break;

            default :
                printf( "error : file %s has been modified\n" );
                exit( -1 );
                break;
        }
    }

    fclose( fd );
    while ( fcnList != NULL )
    {
        prev = fcnList;
        if ( fcnList->isDefine )
        {
            repeat = 1;
            curr = fcnList->next;
            while ( curr != NULL && strcmp( curr->fcnName, fcnList->fcnName ) == 0 )
            {
                if ( curr->isDefine )
                {
                    repeat++;
                    if ( repeat == 2 )
                    {
                        printf( "Multiple definition of function %s : \n", fcnList->fcnName );
                        printf( "\t1 : at line %d of file %s\n", fcnList->lineNo, fcnList->filName );
                        printf( "\t2 : at line %d of file %s\n", curr->lineNo, curr->filName );
                    }
                    else
                    {
                        printf( "\t%d : at line %d of file %s\n", repeat, curr->lineNo, curr->filName );
                    }
                    prev->next = curr->next;
                    curr = prev->next;
                }
                else
                {
                    prev = curr;
                    curr = curr->next; 
                }
            }
        }
        else
        {
            curr = fcnList->next;
            repeat = 1;
            while ( curr != NULL && strcmp( curr->fcnName, fcnList->fcnName ) == 0 && strcmp( curr->modName, fcnList->modName ) == 0 ) 
            {
                if ( !curr->isDefine )
                {
                    repeat++;
                    if ( repeat == 2 )
                    {
                        printf( "Multiple declaration of function %s in module %s\n", fcnList->fcnName, fcnList->modName );
                        printf( "\t1 : at line %d in file %s\n", fcnList->lineNo, fcnList->filName );
                        printf( "\t2 : at line %d in file %s\n", curr->lineNo, curr->filName );
                    }
                    else
                    {
                        printf( "\t%d : at line %d in file %s\n", repeat, curr->lineNo, curr->filName );
                    } 
                    prev->next =curr->next;
                    curr = prev->next;
                }
                else
                {
                    prev = curr;
                    curr = curr->next;
                }
            }
        }
        fcnList = fcnList->next;
    }
}
