/*
 *  Copyright (c) 1988-93 by Abraxas Software.
 *
 *	This is the start of a collection of CodeCheck rules
 *	for testing for portability from either VAX/VMS C or
 *  VAX/ULTRIX C to ANSI standard C.
 */

if ( mod_begin )    // Make sure that VAX keywords are allowed.
	if ( option('K') != 9 )
		warn( 1000, "Use option -K9 for VAX C source code." );

if ( keyword("globaldef") )
	warn( 1001, "The VAX keyword \"globaldef\" is not needed." );

if ( keyword("globalref") )
	warn( 1002, "Substitute \"extern\" for the VAX keyword \"globalref\"." );

if ( keyword("globalvalue") )
	warn( 1003, "Substitute \"long\" for the VAX keyword \"globalvalue\"." );

if ( keyword("noshare") )
	warn( 1004, "The VAX keyword \"noshare\" is not needed." );

if ( keyword("readonly") )
	warn( 1005, "Substitute \"const\" for the VAX keyword \"readonly\"." );

if ( keyword("_align") )
	warn( 1006, "The \"_align\" type modifier phrase is not needed." );

if ( lex_char_long )
	warn( 1007, "Multi-character constants are not portable." );

if ( lex_nonstandard )
	warn( 1008, "Nonstandard character \'%c\' in %s", lex_nonstandard, token() );

if ( lex_assembler )
	warn( 1009, "Embedded assembler is not portable." );
