/*
 *		Copyright (c) 1988-93 by Abraxas Software.
 *
 *		This rule file provides EXAMPLE rules for
 *		every lexical variable in CodeCheck 4.04.
 *
 *		This file is for demonstration purposes only!
 */

int   macro_tokens;  //  counts tokens from macro expansions
int   macro_pct;     //  percent of tokens that come from macros

if ( lex_ansi_escape )
	warn( 1000, "This escape sequence is new with ANSI C." );

if ( lex_assembler )
	warn( 1001, "Embedded assembler code." );

if ( lex_backslash )
	warn( 1002, "This backslash may cause trouble with older compilers." );

if ( lex_bad_call )
	warn( 1003, "Wrong number of arguments in this macro call." );

if ( lex_big_octal )
	warn( 1005, "Octal digits 8 and 9 are not allowed in ANSI C." );

if ( lex_char_empty )
	warn( 1006, "Empty character constants may cause problems." );

if ( lex_char_long )
	warn( 1007, "Multi-character constants are not portable." );

if ( lex_enum_comma )
	warn( 1008, "This comma is not fully portable." );

if ( lex_float )
	warn( 1009, "The suffix F is new with ANSI C." );

if ( lex_hex_escape )
	warn( 1010, "Hexadecimal escape sequence." );

if ( lex_initializer )
	switch ( lex_initializer )
		{
	case 1:
		warn( 1011, "This is a zero initializer." );
		break;
	case 2:
		warn( 1011, "This is a non-zero initializer." );
		break;
	case 3:
		warn( 1011, "This is a character initializer." );
		break;
	case 4:
		warn( 1011, "This is a float or double initializer." );
		break;
	case 5:
		warn( 1011, "This is a string initializer." );
		break;
	case 6:
		warn( 1011, "This is an unclassifiable initializer." );
		break;
		}

if ( lex_intrinsic )
	warn( 1012, "This is an intrinsic function." );

if ( lex_invisible )
	warn( 1013, "This identifier will be invisible to C++ 3.0." );

if ( lex_key_no_space )
	warn( 1014, "This keyword should be followed by whitespace." );

if ( lex_lc_long )
	warn( 1015, "Use an uppercase L here." );

if ( lex_long_float )
	warn( 1016, "This use of the L suffix is new with ANSI C." );

if ( lex_macro_token )
	macro_tokens++;

if ( lex_metaware )
	warn( 1017, "This works with Metaware C only." );
	
if ( lex_nl_eof )
	warn( 1018, "ANSI C requires that every source file end with a newline." );

if ( lex_nonstandard )
	warn( 1019, "Nonstandard character (%c).", lex_nonstandard );

if ( lex_not_KR_escape )
	warn( 1020, "This escape character is not portable to K&R compilers." );

if ( lex_not_manifest )
	if (! lex_initializer )
		{
		warn( 1021, "Use a #define to make this constant \"manifest\"." );
		printf( "Line %d - magic number %s\n", lin_number, token() );
		}

if ( lex_null_arg )
	warn( 1022, "A macro argument is missing." );

if ( lex_num_escape )
	warn( 1023, "Numeric escapes sequences may cause portability problems." );

if ( lex_punct_after )
	warn( 1024, "Place a space after this comma or semicolon." );

if ( lex_punct_before )
	warn( 1025, "Remove the space before this comma or semicolon." );

if ( lex_radix )
	{
	if ( lex_radix == 2 )
		warn( 1026, "Binary constants are allowed only by Zortech compilers." );
	if ( lex_radix == 8 )
		warn( 1027, "Octal constants decrease readability." );
	}

if ( lex_punct_after )
	warn( 1028, "Whitespace after punctuation is recommended." );

if ( lex_punct_before )
	warn( 1029, "Whitespace before punctuation is not recommended." );

if ( lex_str_concat )
	warn( 1030, "Implicit string concatenation is new with ANSI C." );

if ( lex_str_length > 1023 )
	warn( 1031, "This string is too long for some compilers." );

if ( lex_str_macro )
	warn( 1032, "Some compilers will perform macro expansion here." );
	
if ( lex_str_trigraph )
	warn( 1033, "ANSI compilers will detect a trigraph in this string." );

if ( lex_suffix )
	warn( 1034, "Use an explicit cast instead of a suffix." );

if ( keyword("return") )
	if ( lex_token > 1 )
		warn( 1035, "Put this return statement on its own line." );

if ( lex_trigraph )
	warn( 1036, "Trigraphs are new with ANSI C." );

if ( lex_unsigned )
	warn( 1037, "The suffix U is new with ANSI C." );

if ( lex_wide )
	warn( 1038, "Wide string and character constants are new with ANSI C." );

if ( mod_begin )
	{
	macro_tokens = 0;       //  Initialize at module start.
	set_option( 'E', 0 );   //  Make sure option -E is off.
	}

if ( mod_end )
	{
	macro_pct = (100*macro_tokens)/(mod_tokens + macro_tokens);
	warn( 1039, "%d%% of all tokens are from macro expansion.", macro_pct );
	}
