// This rule check if the usage sizeof x exists in code.
// Only usage as sizeof(x) is acceptable for this rule.
// The warning message will be given at the end of each
// statement which contains such kind of usage. And the 
// number of this usage will be given too.

int sizeof_total;
int sizeof_paren;

if (stm_end)
{
  if (sizeof_total!=sizeof_paren)
  {
    warn(1,"%d sizeof operator with unparenthesised operand.",sizeof_total-sizeof_paren);
  }
  sizeof_total=0;
  sizeof_paren=0;
}

if (op_sizeof)
{
  sizeof_total++;
}

if (op_open_paren||op_open_funargs)
{
  if (strcmp(prev_token(),"sizeof")==0)
  {
    sizeof_paren++;
  }
}

