/*	Copyright (c) 1988-94 by Abraxas Software.
 *
 *	This is the start of a collection of CodeCheck rules
 *	for testing for portability to strict K&R C compilers.
 */


#include	<check.cch>

int		k, flags, non_ansi_modifier;

if ( prj_begin )
	non_ansi_modifier = ~(CONST_FLAG + VOLATILE_FLAG);

if ( identifier("entry") )
	warn( 7001, "\"entry\" is a reserved keyword in K&R." );

if ( lex_not_KR_escape )
	warn( 7002, "This escape sequence is not K&R." );

if ( lex_backslash )
	warn( 7003, "This line continuation is not allowed in K&R." );

if ( lex_float || lex_unsigned || lex_long_float )
	warn( 7004, "This suffix is not allowed in K&R." );

if ( (lex_radix == 16) || lex_hex_escape )
	warn( 7005, "Hexadecimal numbers are not K&R." );

if ( lex_str_macro )
	warn( 7006, "Very few K&R compilers will recognize macros in strings." );

if ( lex_str_concat )
	warn( 7007, "Implicit string concatenation is not K&R." );

if ( lex_trigraph )
	warn( 7008, "Trigraphs are not K&R." );

if ( lex_wide )
	warn( 7009, "Wide characters and strings are not K&R." );

if ( pp_error )
	warn( 7010, "The #error preprocessor directive is not K&R." );

if ( pp_paste )
	warn( 7011, "The ## (paste) preprocessor operator is not K&R." );

if ( pp_pragma )
	warn( 7012, "The #pragma preprocessor directive is not K&R." );	

if ( pp_stringize )
	warn( 7013, "The # (stringize) preprocessor operator is not K&R." );

if ( pp_unknown) 
	warn( 7014, "This preprocessor directive is not K&R." );

if ( pp_defined )
	warn( 7015, "The \"defined\" preprocessor function is not K&R." );

if ( pp_elif )
	warn( 7016, "The #elif preprocessor directive is not K&R." );

if ( keyword("const") )
	warn( 7017, "The \"const\" type specifier is not K&R." );

if ( keyword("volatile") )
	warn( 7018, "The \"volatile\" type specifier is not K&R." );

if ( keyword("signed") )
	warn( 7019, "The \"signed\" type specifier is not K&R." );

if ( dcl_function && (! dcl_oldstyle) )
	warn( 7020, "Prototypes are not allowed in K&R." );

if ( dcl_3dots )
	warn( 7021, "The 3-dot notation is not allowed in K&R." );

if ( dcl_need_3dots )
	warn( 7022, "A comma after an argument list is not allowed in K&R." );

if ( dcl_base == ENUM_TYPE )
	warn( 7023, "The enumerated type is not permitted in K&R." );

if ( dcl_base == VOID_TYPE )
	warn( 7024, "The void type is not permitted in K&R." );

if ( dcl_union_init )
	warn( 7025, "Unions cannot be initialized in K&R." );

if ( dcl_global || dcl_static || dcl_local )
	{
	k = 0;
	while ( k <= dcl_levels )
		{
		flags = dcl_level_flags(k++);
		/*
			We check for nonstandard type modifiers this
			way (rather than use the keyword() function)
			because they are spelled in different ways,
			e.g. near, _near, __near.
		*/
		if ( flags & non_ansi_modifier )
			{
			if ( flags & NEAR_FLAG )
				warn( 7026, "The \"near\" modifier is not K&R." );
			if ( flags & FAR_FLAG )
				warn( 7026, "The \"far\" modifier is not K&R." );
			if ( flags & HUGE_FLAG )
				warn( 7026, "The \"huge\" modifier is not K&R." );
			if ( flags & EXPORT_FLAG )
				warn( 7026, "The \"export\" modifier is not K&R." );
			if ( flags & BASED_FLAG )
				warn( 7026, "The \"based\" modifier is not K&R." );
			if ( flags & SEGMENT_FLAG )
				warn( 7026, "The \"segment\" modifier is not K&R." );
			}
		}
	}

if ( lex_nested_comment )
	warn( 7027, "Nested comments are not permitted in K&R." );

if ( lex_cpp_comment )
	warn( 7028, "The // comment is not permitted in K&R." );

if ( dcl_extern_ambig )
	warn( 7029, "%s matches another external name on first 6 characters.", dcl_name() );
