/*	Copyright (c) 1990-93 by Abraxas Software.
 *
 *	This is a collection of CodeCheck rules for testing
 *	for portability to the Apple/MPW C 3.2 compiler.
 *
 *	Source: MPW C 3.2 Release Notes from Apple Computer, Inc.
 *
 */

#include <check.cch>

int		pascal_used;		//	True if pascal has been used.

if ( keyword("near") || keyword("far") || keyword("huge")
		|| keyword("fortran") || keyword("cdecl") )
	warn( 1001, "The keyword %s is not recognized by MPW C.", token() );

if ( identifier("comp") || identifier("extended") )
	warn( 1002, "\"%s\" is a keyword in MPW C.", token() );

if ( pp_include_depth > 15 )
	warn( 1003, "Include depth exceeds the MPW limit (15)." );

if ( pp_if_depth > 48 )
	warn( 1004, "#if nesting exceeds the MPW limit (48)." );

if ( tag_kind == ENUM_TAG )
	if ( tag_members == 0 )
		warn( 1005, "MPW C 3.2 requires at least one enum constant" );

if ( lex_str_length > 512 )
	warn( 1006, "String length exceeds the MPW limit (512)." );

if ( dcl_bitfield_size > 32 )
	warn( 1007, "Bitfield size exceeds the MPW limit (32 bits)." );

if ( keyword("pascal") )
	pascal_used = 1;

if ( dcl_parameter )
	if ( (dcl_base == FLOAT_TYPE) || (dcl_base == DOUBLE_TYPE) )
		if ( pascal_used && dcl_simple )
			warn( 1008, "A bug in MPW C 3.2 will corrupt parameter %s."
					"\n   Use type extended as a work-around.", dcl_name() );

if ( dcl_function )
	pascal_used = 0;

if ( pp_paste )
	warn( 1009, "The MPW preprocessor ## operator is somewhat buggy."
			"\n   See Apple's MPW C 3.2 release notes for details." );
