/*
================================================================
              WHO CALLS A SPECIFIED FUNCTION

This rule prints a list of all calls to a specified function.
Specify the function name with the -X command-line option.

For example, the following command-line asks CodeCheck to scan
the project "myproject" for all calls to the function fprintf.
The output is redirected into the file "check.out".

    check myproject -Rwhocalls -Xfprintf >check.out


LAST REVISED:  11/7/94
AUTHOR:        Loren Cobb
================================================================
*/

if ( op_call )
	{
	if ( strcmp(op_function(), str_option('X')) == 0 )
		printf( "%-20s # File %s.c; Line %d\n",
				fcn_name(), mod_name(), lin_number );
	}
