/*
***************************************************************************
*                                                                         *
* FILE NAME:	cnv.c                                                     *
* COPYRIGHT (C) 1994 BY ABRAXAS SOFTWARE. ALL RIGHTS RESERVED.            *
* AUTHOR:	Shuming Tan                     July 15, 1994             *
* PURPOSE:	This file contains the C code used to test CodeCheck      *
*               predefined variables in cnv_ group accompanying rule      *
*               file cnv.cc                                               *
*                                                                         *
***************************************************************************
*/

/* defined for checking the effect of conversion on function call */

void f1(int len)
{
  int l;

  l=len;
}

main()
{
  /* define a aggregate structure for testing */
  struct person
  {
    char *name;
    int age;
  };

  /* define variables with different types for testing */
  const int i;
  int hand, finger;
  char sun;
  float leg;
  unsigned star;

  char *string1, *string2;
  const *string3="Hello";
  struct person guy1;
  struct person *guy2;

  /* Assign constant values to variables test trigger cnv_truncate */
  hand=2;            
  finger=20;
  leg=2.0;                /* test cnv_truncate */

  string2=string3;

   
  /* test trigger cnv_float_to_int, cnv_int_to_float */
  finger=i;               /* no conversion will occur */
  hand=leg;               /* test cnv_float_to_int */
  leg=finger;             /* test cnv_int_to_float */
  leg=finger+hand;        /* on the right */
  
  /* test the trigger cnv_float_to_int to see if it is effective */
  /* for the type conversion occured in function call.           */
  f1(hand);    
  f1(leg);                /* does conversion in function calls detectable? */

  /* test trigger cnv_signed_to_any */
  star=hand;

  /* test triggers cnv_ptr_to_ptr, cnv_any_ptr */
  string1=&hand;           /* test cnv_ptr_ptr */
  string2=finger;          /* test cnv_any_ptr */

  /* test triggers cnv_ptr_to_ptr with aggregate structure */
  string1=&guy1;     
  string2=guy2;
  string2=(char*)guy2;     /* with cast specified explicitly the trigger should not be pulled */
}

  
